import { world, system, EntityDamageCause } from '@minecraft/server'

world.afterEvents.entityHurt.subscribe((data) => {
    if (data.hurtEntity.typeId != 'counter:damage') {
        const loc = data.hurtEntity.location
        const counter = world.getDimension(data.hurtEntity.dimension.id).spawnEntity('counter:damage', { x: loc.x, y: loc.y + 0, z: loc.z })
        const number = Math.floor(data.damage * 10) / 10
        let color = '§7'
        if (number > 1 || data.damageSource.cause == EntityDamageCause.lightning) {
            color = '§a'
        }
        if (number > 4.9) {
            color = '§e'
        }
        if (number > 9.9) {
            color = '§c'
        }
        if (data.damageSource.cause == EntityDamageCause.fire || data.damageSource.cause == EntityDamageCause.fireTick || data.damageSource.cause == EntityDamageCause.lava || data.damageSource.cause == EntityDamageCause.fireworks || data.damageSource.cause == EntityDamageCause.campfire || data.damageSource.cause == EntityDamageCause.magma || data.damageSource.cause == EntityDamageCause.soulCampfire) {
            color = '§6'
        }
        if (data.damageSource.cause == EntityDamageCause.drowning) {
            color = '§3'
        }
        if (data.damageSource.cause == EntityDamageCause.magic || data.damageSource.cause == EntityDamageCause.thorns) {
            color = '§d'
        }
        if (data.damageSource.cause == EntityDamageCause.starve) {
            color = '§4'
        }
        if (data.damageSource.cause == EntityDamageCause.suffocation || data.damageSource.cause == EntityDamageCause.anvil || data.damageSource.cause == EntityDamageCause.fall || data.damageSource.cause == EntityDamageCause.fallingBlock || data.damageSource.cause == EntityDamageCause.flyIntoWall || data.damageSource.cause == EntityDamageCause.none || data.damageSource.cause == EntityDamageCause.stalactite || data.damageSource.cause == EntityDamageCause.stalagmite) {
            color = '§8'
        }
        if (data.damageSource.cause == EntityDamageCause.freezing) {
            color = '§b'
        }
        if (data.damageSource.cause == EntityDamageCause.contact) {
            color = '§2'
        }
        if (data.damageSource.cause == EntityDamageCause.void || data.damageSource.cause == EntityDamageCause.wither) {
            color = '§0'
        }
        counter.applyImpulse({
            x: -data.hurtEntity.getVelocity().x * 1.2, y: 0.5, z: -data.hurtEntity.getVelocity().z * 1.2
        })
        counter.nameTag = color + JSON.stringify(number)
        system.runTimeout(() => {
            counter.remove()
        }, 17)
    }
})